/* Utils.c generated by valac 0.42.3, the Vala compiler
 * generated from Utils.vala, do not modify */

/*
 * Copyright (c) 2011-2015 elementary LLC. (https://elementary.io)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street - Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define POWER_SERVICES_TYPE_DEVICE (power_services_device_get_type ())
#define POWER_SERVICES_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDevice))
#define POWER_SERVICES_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))
#define POWER_SERVICES_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), POWER_SERVICES_TYPE_DEVICE))
#define POWER_SERVICES_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), POWER_SERVICES_TYPE_DEVICE, PowerServicesDeviceClass))

typedef struct _PowerServicesDevice PowerServicesDevice;
typedef struct _PowerServicesDeviceClass PowerServicesDeviceClass;
#define _g_free0(var) (var = (g_free (var), NULL))



gboolean power_utils_type_is_battery (guint32 device_type);
#define DEVICE_TYPE_UNKNOWN ((guint32) 0)
#define DEVICE_TYPE_LINE_POWER ((guint32) 1)
gboolean power_utils_type_has_device_icon (guint32 device_type);
#define DEVICE_TYPE_PHONE ((guint32) 8)
#define DEVICE_TYPE_MOUSE ((guint32) 5)
#define DEVICE_TYPE_KEYBOARD ((guint32) 6)
#define DEVICE_TYPE_TABLET ((guint32) 10)
GType power_services_device_get_type (void) G_GNUC_CONST;
gchar* power_utils_get_symbolic_icon_name_for_battery (PowerServicesDevice* battery);
gchar* power_utils_get_icon_name_for_battery (PowerServicesDevice* battery);
gdouble power_services_device_get_percentage (PowerServicesDevice* self);
gboolean power_utils_is_charging (guint32 state);
guint32 power_services_device_get_state (PowerServicesDevice* self);
const gchar* power_utils_get_battery_icon (gdouble percentage,
                                           gint64 remaining_time);
gint64 power_services_device_get_time_to_empty (PowerServicesDevice* self);
gchar* power_utils_get_icon_name_for_device (PowerServicesDevice* device);
guint32 power_services_device_get_device_type (PowerServicesDevice* self);
#define DEVICE_STATE_FULLY_CHARGED ((guint32) 4)
#define DEVICE_STATE_CHARGING ((guint32) 1)
gchar* power_utils_get_title_for_battery (PowerServicesDevice* battery);
#define DEVICE_TYPE_BATTERY ((guint32) 2)
#define DEVICE_TYPE_UPS ((guint32) 3)
#define DEVICE_TYPE_MONITOR ((guint32) 4)
#define DEVICE_TYPE_PDA ((guint32) 7)
#define DEVICE_TYPE_MEDIA_PLAYER ((guint32) 9)
#define DEVICE_TYPE_COMPUTER ((guint32) 11)
const gchar* power_services_device_get_vendor (PowerServicesDevice* self);
const gchar* power_services_device_get_model (PowerServicesDevice* self);
gchar* power_utils_get_info_for_battery (PowerServicesDevice* battery);
gint64 power_services_device_get_time_to_full (PowerServicesDevice* self);
#define CONSTANTS_GETTEXT_PACKAGE "power-indicator"
void power_utils_translations (void);


gboolean
power_utils_type_is_battery (guint32 device_type)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 22 "../src/Utils.vala"
	if (device_type != DEVICE_TYPE_UNKNOWN) {
#line 22 "../src/Utils.vala"
		_tmp0_ = device_type != DEVICE_TYPE_LINE_POWER;
#line 92 "Utils.c"
	} else {
#line 22 "../src/Utils.vala"
		_tmp0_ = FALSE;
#line 96 "Utils.c"
	}
#line 22 "../src/Utils.vala"
	result = _tmp0_;
#line 22 "../src/Utils.vala"
	return result;
#line 102 "Utils.c"
}


gboolean
power_utils_type_has_device_icon (guint32 device_type)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 26 "../src/Utils.vala"
	if (device_type == DEVICE_TYPE_PHONE) {
#line 26 "../src/Utils.vala"
		_tmp2_ = TRUE;
#line 117 "Utils.c"
	} else {
#line 27 "../src/Utils.vala"
		_tmp2_ = device_type == DEVICE_TYPE_MOUSE;
#line 121 "Utils.c"
	}
#line 26 "../src/Utils.vala"
	if (_tmp2_) {
#line 26 "../src/Utils.vala"
		_tmp1_ = TRUE;
#line 127 "Utils.c"
	} else {
#line 28 "../src/Utils.vala"
		_tmp1_ = device_type == DEVICE_TYPE_KEYBOARD;
#line 131 "Utils.c"
	}
#line 26 "../src/Utils.vala"
	if (_tmp1_) {
#line 26 "../src/Utils.vala"
		_tmp0_ = TRUE;
#line 137 "Utils.c"
	} else {
#line 29 "../src/Utils.vala"
		_tmp0_ = device_type == DEVICE_TYPE_TABLET;
#line 141 "Utils.c"
	}
#line 26 "../src/Utils.vala"
	result = _tmp0_;
#line 26 "../src/Utils.vala"
	return result;
#line 147 "Utils.c"
}


gchar*
power_utils_get_symbolic_icon_name_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 32 "../src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 33 "../src/Utils.vala"
	_tmp0_ = power_utils_get_icon_name_for_battery (battery);
#line 33 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/Utils.vala"
	_tmp2_ = g_strconcat (_tmp1_, "-symbolic", NULL);
#line 33 "../src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 33 "../src/Utils.vala"
	_g_free0 (_tmp1_);
#line 33 "../src/Utils.vala"
	result = _tmp3_;
#line 33 "../src/Utils.vala"
	return result;
#line 175 "Utils.c"
}


gchar*
power_utils_get_icon_name_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gdouble _tmp1_;
	gdouble _tmp2_;
#line 36 "../src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 37 "../src/Utils.vala"
	_tmp1_ = power_services_device_get_percentage (battery);
#line 37 "../src/Utils.vala"
	_tmp2_ = _tmp1_;
#line 37 "../src/Utils.vala"
	if (_tmp2_ == ((gdouble) 100)) {
#line 194 "Utils.c"
		guint32 _tmp3_;
		guint32 _tmp4_;
#line 37 "../src/Utils.vala"
		_tmp3_ = power_services_device_get_state (battery);
#line 37 "../src/Utils.vala"
		_tmp4_ = _tmp3_;
#line 37 "../src/Utils.vala"
		_tmp0_ = power_utils_is_charging (_tmp4_) == TRUE;
#line 203 "Utils.c"
	} else {
#line 37 "../src/Utils.vala"
		_tmp0_ = FALSE;
#line 207 "Utils.c"
	}
#line 37 "../src/Utils.vala"
	if (_tmp0_) {
#line 211 "Utils.c"
		gchar* _tmp5_;
#line 38 "../src/Utils.vala"
		_tmp5_ = g_strdup ("battery-full-charged");
#line 38 "../src/Utils.vala"
		result = _tmp5_;
#line 38 "../src/Utils.vala"
		return result;
#line 219 "Utils.c"
	} else {
		const gchar* _tmp6_ = NULL;
		guint32 _tmp7_;
		guint32 _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gint64 _tmp11_;
		gint64 _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 41 "../src/Utils.vala"
		_tmp7_ = power_services_device_get_state (battery);
#line 41 "../src/Utils.vala"
		_tmp8_ = _tmp7_;
#line 41 "../src/Utils.vala"
		if (power_utils_is_charging (_tmp8_)) {
#line 41 "../src/Utils.vala"
			_tmp6_ = "-charging";
#line 238 "Utils.c"
		} else {
#line 41 "../src/Utils.vala"
			_tmp6_ = "";
#line 242 "Utils.c"
		}
#line 40 "../src/Utils.vala"
		_tmp9_ = power_services_device_get_percentage (battery);
#line 40 "../src/Utils.vala"
		_tmp10_ = _tmp9_;
#line 40 "../src/Utils.vala"
		_tmp11_ = power_services_device_get_time_to_empty (battery);
#line 40 "../src/Utils.vala"
		_tmp12_ = _tmp11_;
#line 40 "../src/Utils.vala"
		_tmp13_ = power_utils_get_battery_icon (_tmp10_, _tmp12_);
#line 40 "../src/Utils.vala"
		_tmp14_ = g_strconcat (_tmp13_, _tmp6_, NULL);
#line 40 "../src/Utils.vala"
		result = _tmp14_;
#line 40 "../src/Utils.vala"
		return result;
#line 260 "Utils.c"
	}
}


gchar*
power_utils_get_icon_name_for_device (PowerServicesDevice* device)
{
	gchar* result = NULL;
	guint32 _tmp0_;
	guint32 _tmp1_;
#line 45 "../src/Utils.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 46 "../src/Utils.vala"
	_tmp0_ = power_services_device_get_device_type (device);
#line 46 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 46 "../src/Utils.vala"
	switch (_tmp1_) {
#line 46 "../src/Utils.vala"
		case DEVICE_TYPE_PHONE:
#line 281 "Utils.c"
		{
			gchar* _tmp2_;
#line 47 "../src/Utils.vala"
			_tmp2_ = g_strdup ("phone");
#line 47 "../src/Utils.vala"
			result = _tmp2_;
#line 47 "../src/Utils.vala"
			return result;
#line 290 "Utils.c"
		}
#line 46 "../src/Utils.vala"
		case DEVICE_TYPE_MOUSE:
#line 294 "Utils.c"
		{
			gchar* _tmp3_;
#line 48 "../src/Utils.vala"
			_tmp3_ = g_strdup ("input-mouse");
#line 48 "../src/Utils.vala"
			result = _tmp3_;
#line 48 "../src/Utils.vala"
			return result;
#line 303 "Utils.c"
		}
#line 46 "../src/Utils.vala"
		case DEVICE_TYPE_KEYBOARD:
#line 307 "Utils.c"
		{
			gchar* _tmp4_;
#line 49 "../src/Utils.vala"
			_tmp4_ = g_strdup ("input-keyboard");
#line 49 "../src/Utils.vala"
			result = _tmp4_;
#line 49 "../src/Utils.vala"
			return result;
#line 316 "Utils.c"
		}
#line 46 "../src/Utils.vala"
		case DEVICE_TYPE_TABLET:
#line 320 "Utils.c"
		{
			gchar* _tmp5_;
#line 50 "../src/Utils.vala"
			_tmp5_ = g_strdup ("input-tablet");
#line 50 "../src/Utils.vala"
			result = _tmp5_;
#line 50 "../src/Utils.vala"
			return result;
#line 329 "Utils.c"
		}
		default:
		{
			gchar* _tmp6_;
#line 51 "../src/Utils.vala"
			_tmp6_ = power_utils_get_icon_name_for_battery (device);
#line 51 "../src/Utils.vala"
			result = _tmp6_;
#line 51 "../src/Utils.vala"
			return result;
#line 340 "Utils.c"
		}
	}
}


const gchar*
power_utils_get_battery_icon (gdouble percentage,
                              gint64 remaining_time)
{
	const gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
#line 56 "../src/Utils.vala"
	if (percentage <= ((gdouble) 0)) {
#line 57 "../src/Utils.vala"
		result = "battery-good";
#line 57 "../src/Utils.vala"
		return result;
#line 358 "Utils.c"
	}
#line 60 "../src/Utils.vala"
	if (percentage < ((gdouble) 10)) {
#line 362 "Utils.c"
		gboolean _tmp1_ = FALSE;
#line 60 "../src/Utils.vala"
		if (remaining_time == ((gint64) 0)) {
#line 60 "../src/Utils.vala"
			_tmp1_ = TRUE;
#line 368 "Utils.c"
		} else {
#line 60 "../src/Utils.vala"
			_tmp1_ = remaining_time < ((gint64) (30 * 60));
#line 372 "Utils.c"
		}
#line 60 "../src/Utils.vala"
		_tmp0_ = _tmp1_;
#line 376 "Utils.c"
	} else {
#line 60 "../src/Utils.vala"
		_tmp0_ = FALSE;
#line 380 "Utils.c"
	}
#line 60 "../src/Utils.vala"
	if (_tmp0_) {
#line 61 "../src/Utils.vala"
		result = "battery-empty";
#line 61 "../src/Utils.vala"
		return result;
#line 388 "Utils.c"
	}
#line 64 "../src/Utils.vala"
	if (percentage < ((gdouble) 30)) {
#line 65 "../src/Utils.vala"
		result = "battery-caution";
#line 65 "../src/Utils.vala"
		return result;
#line 396 "Utils.c"
	}
#line 68 "../src/Utils.vala"
	if (percentage < ((gdouble) 60)) {
#line 69 "../src/Utils.vala"
		result = "battery-low";
#line 69 "../src/Utils.vala"
		return result;
#line 404 "Utils.c"
	}
#line 72 "../src/Utils.vala"
	if (percentage < ((gdouble) 80)) {
#line 73 "../src/Utils.vala"
		result = "battery-good";
#line 73 "../src/Utils.vala"
		return result;
#line 412 "Utils.c"
	}
#line 76 "../src/Utils.vala"
	result = "battery-full";
#line 76 "../src/Utils.vala"
	return result;
#line 418 "Utils.c"
}


gboolean
power_utils_is_charging (guint32 state)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 80 "../src/Utils.vala"
	if (state == DEVICE_STATE_FULLY_CHARGED) {
#line 80 "../src/Utils.vala"
		_tmp0_ = TRUE;
#line 431 "Utils.c"
	} else {
#line 80 "../src/Utils.vala"
		_tmp0_ = state == DEVICE_STATE_CHARGING;
#line 435 "Utils.c"
	}
#line 80 "../src/Utils.vala"
	result = _tmp0_;
#line 80 "../src/Utils.vala"
	return result;
#line 441 "Utils.c"
}


gchar*
power_utils_get_title_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gchar* title = NULL;
	gchar* _tmp0_;
	guint32 _tmp1_;
	guint32 _tmp2_;
	gboolean _tmp18_ = FALSE;
	guint32 _tmp19_;
	guint32 _tmp20_;
	gboolean _tmp26_ = FALSE;
	guint32 _tmp27_;
	guint32 _tmp28_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
#line 83 "../src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 84 "../src/Utils.vala"
	_tmp0_ = g_strdup ("");
#line 84 "../src/Utils.vala"
	title = _tmp0_;
#line 86 "../src/Utils.vala"
	_tmp1_ = power_services_device_get_device_type (battery);
#line 86 "../src/Utils.vala"
	_tmp2_ = _tmp1_;
#line 86 "../src/Utils.vala"
	switch (_tmp2_) {
#line 86 "../src/Utils.vala"
		case DEVICE_TYPE_BATTERY:
#line 475 "Utils.c"
		{
			gchar* _tmp3_;
#line 88 "../src/Utils.vala"
			_tmp3_ = g_strdup (_ ("Battery"));
#line 88 "../src/Utils.vala"
			_g_free0 (title);
#line 88 "../src/Utils.vala"
			title = _tmp3_;
#line 88 "../src/Utils.vala"
			break;
#line 486 "Utils.c"
		}
#line 86 "../src/Utils.vala"
		case DEVICE_TYPE_UPS:
#line 490 "Utils.c"
		{
			gchar* _tmp4_;
#line 89 "../src/Utils.vala"
			_tmp4_ = g_strdup (_ ("UPS"));
#line 89 "../src/Utils.vala"
			_g_free0 (title);
#line 89 "../src/Utils.vala"
			title = _tmp4_;
#line 89 "../src/Utils.vala"
			break;
#line 501 "Utils.c"
		}
#line 86 "../src/Utils.vala"
		case DEVICE_TYPE_MONITOR:
#line 505 "Utils.c"
		{
			gchar* _tmp5_;
#line 90 "../src/Utils.vala"
			_tmp5_ = g_strdup (_ ("Display"));
#line 90 "../src/Utils.vala"
			_g_free0 (title);
#line 90 "../src/Utils.vala"
			title = _tmp5_;
#line 90 "../src/Utils.vala"
			break;
#line 516 "Utils.c"
		}
#line 86 "../src/Utils.vala"
		case DEVICE_TYPE_MOUSE:
#line 520 "Utils.c"
		{
			gchar* _tmp6_;
#line 91 "../src/Utils.vala"
			_tmp6_ = g_strdup (_ ("Mouse"));
#line 91 "../src/Utils.vala"
			_g_free0 (title);
#line 91 "../src/Utils.vala"
			title = _tmp6_;
#line 91 "../src/Utils.vala"
			break;
#line 531 "Utils.c"
		}
#line 86 "../src/Utils.vala"
		case DEVICE_TYPE_KEYBOARD:
#line 535 "Utils.c"
		{
			gchar* _tmp7_;
#line 92 "../src/Utils.vala"
			_tmp7_ = g_strdup (_ ("Keyboard"));
#line 92 "../src/Utils.vala"
			_g_free0 (title);
#line 92 "../src/Utils.vala"
			title = _tmp7_;
#line 92 "../src/Utils.vala"
			break;
#line 546 "Utils.c"
		}
#line 86 "../src/Utils.vala"
		case DEVICE_TYPE_PDA:
#line 550 "Utils.c"
		{
			gchar* _tmp8_;
#line 93 "../src/Utils.vala"
			_tmp8_ = g_strdup (_ ("PDA"));
#line 93 "../src/Utils.vala"
			_g_free0 (title);
#line 93 "../src/Utils.vala"
			title = _tmp8_;
#line 93 "../src/Utils.vala"
			break;
#line 561 "Utils.c"
		}
#line 86 "../src/Utils.vala"
		case DEVICE_TYPE_PHONE:
#line 565 "Utils.c"
		{
			gchar* _tmp9_;
#line 94 "../src/Utils.vala"
			_tmp9_ = g_strdup (_ ("Phone"));
#line 94 "../src/Utils.vala"
			_g_free0 (title);
#line 94 "../src/Utils.vala"
			title = _tmp9_;
#line 94 "../src/Utils.vala"
			break;
#line 576 "Utils.c"
		}
#line 86 "../src/Utils.vala"
		case DEVICE_TYPE_MEDIA_PLAYER:
#line 580 "Utils.c"
		{
			gchar* _tmp10_;
#line 95 "../src/Utils.vala"
			_tmp10_ = g_strdup (_ ("Media Player"));
#line 95 "../src/Utils.vala"
			_g_free0 (title);
#line 95 "../src/Utils.vala"
			title = _tmp10_;
#line 95 "../src/Utils.vala"
			break;
#line 591 "Utils.c"
		}
#line 86 "../src/Utils.vala"
		case DEVICE_TYPE_TABLET:
#line 595 "Utils.c"
		{
			gchar* _tmp11_;
#line 96 "../src/Utils.vala"
			_tmp11_ = g_strdup (_ ("Tablet"));
#line 96 "../src/Utils.vala"
			_g_free0 (title);
#line 96 "../src/Utils.vala"
			title = _tmp11_;
#line 96 "../src/Utils.vala"
			break;
#line 606 "Utils.c"
		}
#line 86 "../src/Utils.vala"
		case DEVICE_TYPE_COMPUTER:
#line 610 "Utils.c"
		{
			gchar* _tmp12_;
#line 97 "../src/Utils.vala"
			_tmp12_ = g_strdup (_ ("Computer"));
#line 97 "../src/Utils.vala"
			_g_free0 (title);
#line 97 "../src/Utils.vala"
			title = _tmp12_;
#line 97 "../src/Utils.vala"
			break;
#line 621 "Utils.c"
		}
		default:
		{
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			gchar* _tmp17_;
#line 98 "../src/Utils.vala"
			_tmp13_ = power_services_device_get_vendor (battery);
#line 98 "../src/Utils.vala"
			_tmp14_ = _tmp13_;
#line 98 "../src/Utils.vala"
			_tmp15_ = g_strconcat (_tmp14_, " ", NULL);
#line 98 "../src/Utils.vala"
			_tmp16_ = _tmp15_;
#line 98 "../src/Utils.vala"
			_tmp17_ = g_strconcat (_tmp16_, _ ("Device"), NULL);
#line 98 "../src/Utils.vala"
			_g_free0 (title);
#line 98 "../src/Utils.vala"
			title = _tmp17_;
#line 98 "../src/Utils.vala"
			_g_free0 (_tmp16_);
#line 98 "../src/Utils.vala"
			break;
#line 648 "Utils.c"
		}
	}
#line 101 "../src/Utils.vala"
	_tmp19_ = power_services_device_get_device_type (battery);
#line 101 "../src/Utils.vala"
	_tmp20_ = _tmp19_;
#line 101 "../src/Utils.vala"
	if (_tmp20_ == DEVICE_TYPE_PHONE) {
#line 657 "Utils.c"
		const gchar* _tmp21_;
		const gchar* _tmp22_;
#line 101 "../src/Utils.vala"
		_tmp21_ = power_services_device_get_model (battery);
#line 101 "../src/Utils.vala"
		_tmp22_ = _tmp21_;
#line 101 "../src/Utils.vala"
		_tmp18_ = g_strcmp0 (_tmp22_, "") != 0;
#line 666 "Utils.c"
	} else {
#line 101 "../src/Utils.vala"
		_tmp18_ = FALSE;
#line 670 "Utils.c"
	}
#line 101 "../src/Utils.vala"
	if (_tmp18_) {
#line 674 "Utils.c"
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
#line 102 "../src/Utils.vala"
		_tmp23_ = power_services_device_get_model (battery);
#line 102 "../src/Utils.vala"
		_tmp24_ = _tmp23_;
#line 102 "../src/Utils.vala"
		_tmp25_ = g_strdup (_tmp24_);
#line 102 "../src/Utils.vala"
		_g_free0 (title);
#line 102 "../src/Utils.vala"
		title = _tmp25_;
#line 688 "Utils.c"
	}
#line 105 "../src/Utils.vala"
	_tmp27_ = power_services_device_get_device_type (battery);
#line 105 "../src/Utils.vala"
	_tmp28_ = _tmp27_;
#line 105 "../src/Utils.vala"
	if (_tmp28_ == DEVICE_TYPE_TABLET) {
#line 696 "Utils.c"
		const gchar* _tmp29_;
		const gchar* _tmp30_;
#line 105 "../src/Utils.vala"
		_tmp29_ = power_services_device_get_model (battery);
#line 105 "../src/Utils.vala"
		_tmp30_ = _tmp29_;
#line 105 "../src/Utils.vala"
		_tmp26_ = g_strcmp0 (_tmp30_, "") != 0;
#line 705 "Utils.c"
	} else {
#line 105 "../src/Utils.vala"
		_tmp26_ = FALSE;
#line 709 "Utils.c"
	}
#line 105 "../src/Utils.vala"
	if (_tmp26_) {
#line 713 "Utils.c"
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
#line 106 "../src/Utils.vala"
		_tmp31_ = power_services_device_get_model (battery);
#line 106 "../src/Utils.vala"
		_tmp32_ = _tmp31_;
#line 106 "../src/Utils.vala"
		_tmp33_ = g_strdup (_tmp32_);
#line 106 "../src/Utils.vala"
		_g_free0 (title);
#line 106 "../src/Utils.vala"
		title = _tmp33_;
#line 727 "Utils.c"
	}
#line 109 "../src/Utils.vala"
	_tmp34_ = title;
#line 109 "../src/Utils.vala"
	_tmp35_ = g_strdup_printf ("<b>%s</b>", _tmp34_);
#line 109 "../src/Utils.vala"
	result = _tmp35_;
#line 109 "../src/Utils.vala"
	_g_free0 (title);
#line 109 "../src/Utils.vala"
	return result;
#line 739 "Utils.c"
}


gchar*
power_utils_get_info_for_battery (PowerServicesDevice* battery)
{
	gchar* result = NULL;
	gint percent = 0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gboolean charging = FALSE;
	guint32 _tmp2_;
	guint32 _tmp3_;
	gint _tmp4_;
	gchar* info = NULL;
	gchar* _tmp6_;
	gboolean _tmp7_;
#line 112 "../src/Utils.vala"
	g_return_val_if_fail (battery != NULL, NULL);
#line 113 "../src/Utils.vala"
	_tmp0_ = power_services_device_get_percentage (battery);
#line 113 "../src/Utils.vala"
	_tmp1_ = _tmp0_;
#line 113 "../src/Utils.vala"
	percent = (gint) round (_tmp1_);
#line 114 "../src/Utils.vala"
	_tmp2_ = power_services_device_get_state (battery);
#line 114 "../src/Utils.vala"
	_tmp3_ = _tmp2_;
#line 114 "../src/Utils.vala"
	charging = power_utils_is_charging (_tmp3_);
#line 116 "../src/Utils.vala"
	_tmp4_ = percent;
#line 116 "../src/Utils.vala"
	if (_tmp4_ <= 0) {
#line 775 "Utils.c"
		gchar* _tmp5_;
#line 117 "../src/Utils.vala"
		_tmp5_ = g_strdup (_ ("Calculating…"));
#line 117 "../src/Utils.vala"
		result = _tmp5_;
#line 117 "../src/Utils.vala"
		return result;
#line 783 "Utils.c"
	}
#line 120 "../src/Utils.vala"
	_tmp6_ = g_strdup ("");
#line 120 "../src/Utils.vala"
	info = _tmp6_;
#line 122 "../src/Utils.vala"
	_tmp7_ = charging;
#line 122 "../src/Utils.vala"
	if (_tmp7_) {
#line 793 "Utils.c"
		const gchar* _tmp8_;
		gint _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gint64 seconds = 0LL;
		gint64 _tmp13_;
		gint64 _tmp14_;
		gint64 _tmp15_;
#line 123 "../src/Utils.vala"
		_tmp8_ = info;
#line 123 "../src/Utils.vala"
		_tmp9_ = percent;
#line 123 "../src/Utils.vala"
		_tmp10_ = g_strdup_printf (_ ("%i%% charged"), _tmp9_);
#line 123 "../src/Utils.vala"
		_tmp11_ = _tmp10_;
#line 123 "../src/Utils.vala"
		_tmp12_ = g_strconcat (_tmp8_, _tmp11_, NULL);
#line 123 "../src/Utils.vala"
		_g_free0 (info);
#line 123 "../src/Utils.vala"
		info = _tmp12_;
#line 123 "../src/Utils.vala"
		_g_free0 (_tmp11_);
#line 125 "../src/Utils.vala"
		_tmp13_ = power_services_device_get_time_to_full (battery);
#line 125 "../src/Utils.vala"
		_tmp14_ = _tmp13_;
#line 125 "../src/Utils.vala"
		seconds = _tmp14_;
#line 127 "../src/Utils.vala"
		_tmp15_ = seconds;
#line 127 "../src/Utils.vala"
		if (_tmp15_ > ((gint64) 0)) {
#line 829 "Utils.c"
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gint64 _tmp18_;
#line 128 "../src/Utils.vala"
			_tmp16_ = info;
#line 128 "../src/Utils.vala"
			_tmp17_ = g_strconcat (_tmp16_, " - ", NULL);
#line 128 "../src/Utils.vala"
			_g_free0 (info);
#line 128 "../src/Utils.vala"
			info = _tmp17_;
#line 129 "../src/Utils.vala"
			_tmp18_ = seconds;
#line 129 "../src/Utils.vala"
			if (_tmp18_ >= ((gint64) 86400)) {
#line 845 "Utils.c"
				gint64 days = 0LL;
				gint64 _tmp19_;
				const gchar* _tmp20_;
				gint64 _tmp21_;
				gint64 _tmp22_;
				gchar* _tmp23_;
				gchar* _tmp24_;
				gchar* _tmp25_;
#line 130 "../src/Utils.vala"
				_tmp19_ = seconds;
#line 130 "../src/Utils.vala"
				days = _tmp19_ / 86400;
#line 131 "../src/Utils.vala"
				_tmp20_ = info;
#line 131 "../src/Utils.vala"
				_tmp21_ = days;
#line 131 "../src/Utils.vala"
				_tmp22_ = days;
#line 131 "../src/Utils.vala"
				_tmp23_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld day until full", "%lld days until full", (gulong) _tmp21_), _tmp22_);
#line 131 "../src/Utils.vala"
				_tmp24_ = _tmp23_;
#line 131 "../src/Utils.vala"
				_tmp25_ = g_strconcat (_tmp20_, _tmp24_, NULL);
#line 131 "../src/Utils.vala"
				_g_free0 (info);
#line 131 "../src/Utils.vala"
				info = _tmp25_;
#line 131 "../src/Utils.vala"
				_g_free0 (_tmp24_);
#line 876 "Utils.c"
			} else {
				gint64 _tmp26_;
#line 132 "../src/Utils.vala"
				_tmp26_ = seconds;
#line 132 "../src/Utils.vala"
				if (_tmp26_ >= ((gint64) 3600)) {
#line 883 "Utils.c"
					gint64 hours = 0LL;
					gint64 _tmp27_;
					const gchar* _tmp28_;
					gint64 _tmp29_;
					gint64 _tmp30_;
					gchar* _tmp31_;
					gchar* _tmp32_;
					gchar* _tmp33_;
#line 133 "../src/Utils.vala"
					_tmp27_ = seconds;
#line 133 "../src/Utils.vala"
					hours = _tmp27_ / 3600;
#line 134 "../src/Utils.vala"
					_tmp28_ = info;
#line 134 "../src/Utils.vala"
					_tmp29_ = hours;
#line 134 "../src/Utils.vala"
					_tmp30_ = hours;
#line 134 "../src/Utils.vala"
					_tmp31_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until full", "%lld hours until full", (gulong) _tmp29_), _tmp30_);
#line 134 "../src/Utils.vala"
					_tmp32_ = _tmp31_;
#line 134 "../src/Utils.vala"
					_tmp33_ = g_strconcat (_tmp28_, _tmp32_, NULL);
#line 134 "../src/Utils.vala"
					_g_free0 (info);
#line 134 "../src/Utils.vala"
					info = _tmp33_;
#line 134 "../src/Utils.vala"
					_g_free0 (_tmp32_);
#line 914 "Utils.c"
				} else {
					gint64 _tmp34_;
#line 135 "../src/Utils.vala"
					_tmp34_ = seconds;
#line 135 "../src/Utils.vala"
					if (_tmp34_ >= ((gint64) 60)) {
#line 921 "Utils.c"
						gint64 minutes = 0LL;
						gint64 _tmp35_;
						const gchar* _tmp36_;
						gint64 _tmp37_;
						gint64 _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
#line 136 "../src/Utils.vala"
						_tmp35_ = seconds;
#line 136 "../src/Utils.vala"
						minutes = _tmp35_ / 60;
#line 137 "../src/Utils.vala"
						_tmp36_ = info;
#line 137 "../src/Utils.vala"
						_tmp37_ = minutes;
#line 137 "../src/Utils.vala"
						_tmp38_ = minutes;
#line 137 "../src/Utils.vala"
						_tmp39_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until full", "%lld minutes until full", (gulong) _tmp37_), _tmp38_);
#line 137 "../src/Utils.vala"
						_tmp40_ = _tmp39_;
#line 137 "../src/Utils.vala"
						_tmp41_ = g_strconcat (_tmp36_, _tmp40_, NULL);
#line 137 "../src/Utils.vala"
						_g_free0 (info);
#line 137 "../src/Utils.vala"
						info = _tmp41_;
#line 137 "../src/Utils.vala"
						_g_free0 (_tmp40_);
#line 952 "Utils.c"
					} else {
						const gchar* _tmp42_;
						gint64 _tmp43_;
						gint64 _tmp44_;
						gchar* _tmp45_;
						gchar* _tmp46_;
						gchar* _tmp47_;
#line 139 "../src/Utils.vala"
						_tmp42_ = info;
#line 139 "../src/Utils.vala"
						_tmp43_ = seconds;
#line 139 "../src/Utils.vala"
						_tmp44_ = seconds;
#line 139 "../src/Utils.vala"
						_tmp45_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until full", "%lld seconds until full", (gulong) _tmp43_), _tmp44_);
#line 139 "../src/Utils.vala"
						_tmp46_ = _tmp45_;
#line 139 "../src/Utils.vala"
						_tmp47_ = g_strconcat (_tmp42_, _tmp46_, NULL);
#line 139 "../src/Utils.vala"
						_g_free0 (info);
#line 139 "../src/Utils.vala"
						info = _tmp47_;
#line 139 "../src/Utils.vala"
						_g_free0 (_tmp46_);
#line 978 "Utils.c"
					}
				}
			}
		}
	} else {
		const gchar* _tmp48_;
		gint _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gint64 seconds = 0LL;
		gint64 _tmp53_;
		gint64 _tmp54_;
		gint64 _tmp55_;
#line 143 "../src/Utils.vala"
		_tmp48_ = info;
#line 143 "../src/Utils.vala"
		_tmp49_ = percent;
#line 143 "../src/Utils.vala"
		_tmp50_ = g_strdup_printf (_ ("%i%% remaining"), _tmp49_);
#line 143 "../src/Utils.vala"
		_tmp51_ = _tmp50_;
#line 143 "../src/Utils.vala"
		_tmp52_ = g_strconcat (_tmp48_, _tmp51_, NULL);
#line 143 "../src/Utils.vala"
		_g_free0 (info);
#line 143 "../src/Utils.vala"
		info = _tmp52_;
#line 143 "../src/Utils.vala"
		_g_free0 (_tmp51_);
#line 145 "../src/Utils.vala"
		_tmp53_ = power_services_device_get_time_to_empty (battery);
#line 145 "../src/Utils.vala"
		_tmp54_ = _tmp53_;
#line 145 "../src/Utils.vala"
		seconds = _tmp54_;
#line 147 "../src/Utils.vala"
		_tmp55_ = seconds;
#line 147 "../src/Utils.vala"
		if (_tmp55_ > ((gint64) 0)) {
#line 1019 "Utils.c"
			const gchar* _tmp56_;
			gchar* _tmp57_;
			gint64 _tmp58_;
#line 148 "../src/Utils.vala"
			_tmp56_ = info;
#line 148 "../src/Utils.vala"
			_tmp57_ = g_strconcat (_tmp56_, " - ", NULL);
#line 148 "../src/Utils.vala"
			_g_free0 (info);
#line 148 "../src/Utils.vala"
			info = _tmp57_;
#line 149 "../src/Utils.vala"
			_tmp58_ = seconds;
#line 149 "../src/Utils.vala"
			if (_tmp58_ >= ((gint64) 86400)) {
#line 1035 "Utils.c"
				gint64 days = 0LL;
				gint64 _tmp59_;
				const gchar* _tmp60_;
				gint64 _tmp61_;
				gint64 _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
				gchar* _tmp65_;
#line 150 "../src/Utils.vala"
				_tmp59_ = seconds;
#line 150 "../src/Utils.vala"
				days = _tmp59_ / 86400;
#line 151 "../src/Utils.vala"
				_tmp60_ = info;
#line 151 "../src/Utils.vala"
				_tmp61_ = days;
#line 151 "../src/Utils.vala"
				_tmp62_ = days;
#line 151 "../src/Utils.vala"
				_tmp63_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld day until empty", "%lld days until empty", (gulong) _tmp61_), _tmp62_);
#line 151 "../src/Utils.vala"
				_tmp64_ = _tmp63_;
#line 151 "../src/Utils.vala"
				_tmp65_ = g_strconcat (_tmp60_, _tmp64_, NULL);
#line 151 "../src/Utils.vala"
				_g_free0 (info);
#line 151 "../src/Utils.vala"
				info = _tmp65_;
#line 151 "../src/Utils.vala"
				_g_free0 (_tmp64_);
#line 1066 "Utils.c"
			} else {
				gint64 _tmp66_;
#line 152 "../src/Utils.vala"
				_tmp66_ = seconds;
#line 152 "../src/Utils.vala"
				if (_tmp66_ >= ((gint64) 3600)) {
#line 1073 "Utils.c"
					gint64 hours = 0LL;
					gint64 _tmp67_;
					const gchar* _tmp68_;
					gint64 _tmp69_;
					gint64 _tmp70_;
					gchar* _tmp71_;
					gchar* _tmp72_;
					gchar* _tmp73_;
#line 153 "../src/Utils.vala"
					_tmp67_ = seconds;
#line 153 "../src/Utils.vala"
					hours = _tmp67_ / 3600;
#line 154 "../src/Utils.vala"
					_tmp68_ = info;
#line 154 "../src/Utils.vala"
					_tmp69_ = hours;
#line 154 "../src/Utils.vala"
					_tmp70_ = hours;
#line 154 "../src/Utils.vala"
					_tmp71_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld hour until empty", "%lld hours until empty", (gulong) _tmp69_), _tmp70_);
#line 154 "../src/Utils.vala"
					_tmp72_ = _tmp71_;
#line 154 "../src/Utils.vala"
					_tmp73_ = g_strconcat (_tmp68_, _tmp72_, NULL);
#line 154 "../src/Utils.vala"
					_g_free0 (info);
#line 154 "../src/Utils.vala"
					info = _tmp73_;
#line 154 "../src/Utils.vala"
					_g_free0 (_tmp72_);
#line 1104 "Utils.c"
				} else {
					gint64 _tmp74_;
#line 155 "../src/Utils.vala"
					_tmp74_ = seconds;
#line 155 "../src/Utils.vala"
					if (_tmp74_ >= ((gint64) 60)) {
#line 1111 "Utils.c"
						gint64 minutes = 0LL;
						gint64 _tmp75_;
						const gchar* _tmp76_;
						gint64 _tmp77_;
						gint64 _tmp78_;
						gchar* _tmp79_;
						gchar* _tmp80_;
						gchar* _tmp81_;
#line 156 "../src/Utils.vala"
						_tmp75_ = seconds;
#line 156 "../src/Utils.vala"
						minutes = _tmp75_ / 60;
#line 157 "../src/Utils.vala"
						_tmp76_ = info;
#line 157 "../src/Utils.vala"
						_tmp77_ = minutes;
#line 157 "../src/Utils.vala"
						_tmp78_ = minutes;
#line 157 "../src/Utils.vala"
						_tmp79_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld minute until empty", "%lld minutes until empty", (gulong) _tmp77_), _tmp78_);
#line 157 "../src/Utils.vala"
						_tmp80_ = _tmp79_;
#line 157 "../src/Utils.vala"
						_tmp81_ = g_strconcat (_tmp76_, _tmp80_, NULL);
#line 157 "../src/Utils.vala"
						_g_free0 (info);
#line 157 "../src/Utils.vala"
						info = _tmp81_;
#line 157 "../src/Utils.vala"
						_g_free0 (_tmp80_);
#line 1142 "Utils.c"
					} else {
						const gchar* _tmp82_;
						gint64 _tmp83_;
						gint64 _tmp84_;
						gchar* _tmp85_;
						gchar* _tmp86_;
						gchar* _tmp87_;
#line 159 "../src/Utils.vala"
						_tmp82_ = info;
#line 159 "../src/Utils.vala"
						_tmp83_ = seconds;
#line 159 "../src/Utils.vala"
						_tmp84_ = seconds;
#line 159 "../src/Utils.vala"
						_tmp85_ = g_strdup_printf (g_dngettext (CONSTANTS_GETTEXT_PACKAGE, "%lld second until empty", "%lld seconds until empty", (gulong) _tmp83_), _tmp84_);
#line 159 "../src/Utils.vala"
						_tmp86_ = _tmp85_;
#line 159 "../src/Utils.vala"
						_tmp87_ = g_strconcat (_tmp82_, _tmp86_, NULL);
#line 159 "../src/Utils.vala"
						_g_free0 (info);
#line 159 "../src/Utils.vala"
						info = _tmp87_;
#line 159 "../src/Utils.vala"
						_g_free0 (_tmp86_);
#line 1168 "Utils.c"
					}
				}
			}
		}
	}
#line 164 "../src/Utils.vala"
	result = info;
#line 164 "../src/Utils.vala"
	return result;
#line 1178 "Utils.c"
}


void
power_utils_translations (void)
{
#line 169 "../src/Utils.vala"
	ngettext ("%lld day until full", "%lld days until full", (gulong) 0);
#line 170 "../src/Utils.vala"
	ngettext ("%lld hour until full", "%lld hours until full", (gulong) 0);
#line 171 "../src/Utils.vala"
	ngettext ("%lld minute until full", "%lld minutes until full", (gulong) 0);
#line 172 "../src/Utils.vala"
	ngettext ("%lld second until full", "%lld seconds until full", (gulong) 0);
#line 173 "../src/Utils.vala"
	ngettext ("%lld day until empty", "%lld days until empty", (gulong) 0);
#line 174 "../src/Utils.vala"
	ngettext ("%lld hour until empty", "%lld hours until empty", (gulong) 0);
#line 175 "../src/Utils.vala"
	ngettext ("%lld minute until empty", "%lld minutes until empty", (gulong) 0);
#line 176 "../src/Utils.vala"
	ngettext ("%lld second until empty", "%lld seconds until empty", (gulong) 0);
#line 1201 "Utils.c"
}



